import java.awt.Canvas;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.image.BufferedImage;


public class Contador extends Canvas{


	private static final long serialVersionUID = 1L;
	//Variables cronometro
	private boolean contActivo;		//boolean esta contando?
	private int seg;				//int contador de segundos (mod 60)
	private int min;				//int contador de  minutos (sin mod)
	private long tReferencia; // tiempo inicial
	private long tActual; //ultimo calculo de tiempo
	
	
	public Contador(){
		contActivo=false;
		this.setBounds(10, 5, 60, 15);
		seg=min=0;
		
	}

	
	public void creaContador(){
		contActivo=true;
		seg=min=0;
		tReferencia = System.currentTimeMillis();
	}
	
	public String toString(){
		if (contActivo){
			contar();
		}
		return new String("{ "+min+" : "+seg+" }");
	}
	
	public void contar(){
		tActual = System.currentTimeMillis();
		
		long tiempo = tActual - tReferencia;
		
		tiempo /= 1000;
		
		seg = (int)tiempo%60;
		min = (int)(tiempo-seg)/60;	
	}
	
	public boolean getActivo(){
		return contActivo;
	}
	
	public void resuelve(){
		pararContador();
		min=99;
		seg=99;
	}
	
	public void pararContador(){
		contActivo=false;
	}
	
	// Llama directamente a paint(), evitando el borrado del componente
   public void update (Graphics g){
	      paint (g);
   }

   public void paint (Graphics g) {
	      // Se crea una imagen del mismo tamao que el Canvas
	      BufferedImage imagen = new BufferedImage (getWidth(), getHeight(), BufferedImage.TYPE_INT_RGB);

	      // Se dibuja en la imagen
	     Graphics gs = imagen.getGraphics();
	      gs.setColor(new Color(238,238,238));
	      gs.fillRect(0, 0, this.getWidth(), this.getHeight());
	      gs.setColor(new Color(255,0,0));
	     gs.drawString(this.toString(), 0, 2*getHeight()/3);

	      // Se "pega" la imagen sobre el componente
	      g.drawImage(imagen, 0, 0, this);
	      
	      try{
	    	  //TODO mejorar la implemenctacion
	    	  //Dormimos el hilo 1 ms
	    	  //misteriosamente resuelve el problema de CPU
	    	  Thread.sleep(1);
	    	  repaint();
	      }catch(InterruptedException e){}
	      
	   }
}
